//
//  SelfieWorker.swift
//  FADModulePhoto
//
//  Created by Juan Carlos Pérez on 1/25/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit
import AVFoundation
import FirebaseMLVision

class SelfieWorker
{
    
    /// Dispatch Queue
    fileprivate var sessionQueue: DispatchQueue = DispatchQueue(label: "videoQueue", attributes: [])
    
    
    func initializeCameraSession(selectFrontCamera : Bool) -> Selfie.Camera.Session{
        
        var frontCameraDevice: AVCaptureDevice?
        
        let session = AVCaptureSession()
        session.beginConfiguration()
        session.sessionPreset = AVCaptureSession.Preset(rawValue: convertFromAVCaptureSessionPreset(AVCaptureSession.Preset.high))
        
        frontCameraDevice = getCameraWithPosition(position: selectFrontCamera == true ? .front : .back)
        
        frontCameraDevice = self.prepareCameraDevice(cameraDevice: frontCameraDevice)
        
        var response = Selfie.Camera.Session()
        response.camSession = session
        response.frontCameraDevice = frontCameraDevice
        
        return response
    }
    
    
    // Find a camera with the specified AVCaptureDevicePosition, returning nil if one is not found
    private func getCameraWithPosition(position: AVCaptureDevice.Position) -> AVCaptureDevice?
    {
        let devices = AVCaptureDevice.devices(for: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))
        for device in devices {
            let device = device 
            if device.position == position {
                return device
            }
        }
        
        return nil
    }
    
    private func prepareCameraDevice(cameraDevice: AVCaptureDevice?)-> AVCaptureDevice?{
        
        do {
            try cameraDevice?.lockForConfiguration()
            
            if (cameraDevice?.isFocusModeSupported(.continuousAutoFocus))!{
                cameraDevice?.focusMode = .continuousAutoFocus
                if (cameraDevice?.isSmoothAutoFocusSupported)! {
                    cameraDevice?.isSmoothAutoFocusEnabled = true
                }
            }
            if (cameraDevice?.isExposureModeSupported(.continuousAutoExposure))!{
                cameraDevice?.exposureMode = .continuousAutoExposure
            }
            if (cameraDevice?.isWhiteBalanceModeSupported(.continuousAutoWhiteBalance))!{
                cameraDevice?.whiteBalanceMode = .continuousAutoWhiteBalance
            }
            if (cameraDevice?.isLowLightBoostSupported)!{
                cameraDevice?.automaticallyEnablesLowLightBoostWhenAvailable = true
            }
            cameraDevice?.unlockForConfiguration()
        }catch{
            print(error.localizedDescription)
        }
        
        return cameraDevice
    }
   
    
    func switchCamera(camSession: AVCaptureSession?) -> Selfie.Camera.Session {
        
        var response = Selfie.Camera.Session()
        response.camSession = camSession
        
        if let session = camSession {

            session.beginConfiguration()
            
            let currentCameraInput = session.inputs.first! //as! AVCaptureInput
            session.removeInput(currentCameraInput)
            
            for output in session.outputs{
                if let ou = output as? AVCaptureVideoDataOutput{
                    session.removeOutput(ou)
                }
            }
            
            var newCamera:AVCaptureDevice! = nil
            if let input = currentCameraInput as? AVCaptureDeviceInput {
                newCamera = getCameraWithPosition(position: input.device.position == .back ? .front : .back)
            }
            
            newCamera = self.prepareCameraDevice(cameraDevice: newCamera)
            
            response.camSession = session
            response.frontCameraDevice = newCamera
            
        }
        
         return response
    }
    
    func setupCameraSession(camSession: AVCaptureSession?, cameraDevice: AVCaptureDevice?, captureVideoDataOutputSampleBufferDelegate: AVCaptureVideoDataOutputSampleBufferDelegate?) -> AVCaptureVideoDataOutput?{
        
         let orientation = UIApplication.shared.statusBarOrientation
        
        do {
            let inputCamera = try AVCaptureDeviceInput(device: cameraDevice!)
            if (camSession?.canAddInput(inputCamera))!{
                camSession?.addInput(inputCamera)
            }
            
            let videoOutput = AVCaptureVideoDataOutput()
            if (camSession?.canAddOutput(videoOutput))!{
                camSession?.addOutput(videoOutput)
                videoOutput.setSampleBufferDelegate(captureVideoDataOutputSampleBufferDelegate, queue: sessionQueue)
            }
            
            let captureConnection = videoOutput.connection(with: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))
            if orientation == UIInterfaceOrientation.landscapeRight {
                captureConnection?.videoOrientation = .landscapeRight
            } else {
                if orientation == UIInterfaceOrientation.landscapeLeft {
                    captureConnection?.videoOrientation = AVCaptureVideoOrientation.landscapeLeft
                }
            }
            camSession?.commitConfiguration()
            
             return videoOutput
        }catch{
            print(error.localizedDescription)
        }
        
        return nil
    }
    
    
    
    /// Start the session
    func startRecognition(request: Selfie.Config.Request) {
        if !(request.camSession?.isRunning)! {
            request.camSession?.startRunning()
        }
    }
    
    /// Stop the session
    func stopRecognition (request: Selfie.Config.Request) {
        if (request.camSession?.isRunning)!{
            request.camSession?.stopRunning()
        }
    }
    
    
    func processSmile(smile: Int, glassesTimeStamps : [Double], face : VisionFace) -> Selfie.SmileDetector.Response{
        
        var glassesTimeStamps = glassesTimeStamps
        var smileResult = smile
        
        print(smile)
        switch smile{
        case 0:
            //no sonrisa
            if face.smilingProbability < Constants.smileProbability {
                smileResult = 1
                glassesTimeStamps = []
            }
            break
            
        case 1:
            //sonrisa
            if face.smilingProbability > Constants.smileProbability{
                
                glassesTimeStamps.append(Double(NSDate().timeIntervalSince1970))
                if glassesTimeStamps.count > 1{
                    let diffTime = glassesTimeStamps[1]-glassesTimeStamps[0]
                    if diffTime < 1 {
                        smileResult = 2
                        print("Smile")
                    }else{
                        glassesTimeStamps.removeAll()
                    }
                }
            }
            break
            
        case 2:
            //no sonrisa
            if face.smilingProbability < Constants.smileProbability {
                smileResult = 3
            }
            break
            
        case 3:
             smileResult = 4
            //self.updateProofIndex(index: self.actualStateIndex)
            break
            
        default:
            break
        }
        
        var response = Selfie.SmileDetector.Response()
        response.smileResult = smileResult
        response.glassesTimeStamps = glassesTimeStamps
        
        return response
    }
    
    
    func processBlink(blink: Int, glassesTimeStamps : [Double], face : VisionFace) -> Selfie.BlinkDetector.Response{
    
        var glassesTimeStamps = glassesTimeStamps
        var blinkResult = blink
        
        
        switch blink{
            
        case 0:
            if face.leftEyeOpenProbability > Constants.openEyesProbability && face.rightEyeOpenProbability > Constants.openEyesProbability  && face.smilingProbability < Constants.smileProbability{
                blinkResult = 1
                glassesTimeStamps = []
            }
            break
            
        case 1:
            if face.leftEyeOpenProbability < Constants.closeEyesProbability && face.rightEyeOpenProbability < Constants.closeEyesProbability && face.smilingProbability < Constants.smileProbability{
                //blink = 2
                print("eyes closed")
                glassesTimeStamps.append(Double(NSDate().timeIntervalSince1970))
                
                if glassesTimeStamps.count > 1{
                    let diffTime = glassesTimeStamps[1]-glassesTimeStamps[0]
                    if diffTime < 1 {
                        blinkResult = 2
                        print("Eyes closed")
                    }else{
                        glassesTimeStamps.removeAll()
                    }
                }
            }
            break
            
        case 2:
            if face.leftEyeOpenProbability > Constants.openEyesProbability && face.rightEyeOpenProbability > Constants.openEyesProbability && face.smilingProbability < Constants.smileProbability{
                blinkResult = 3
            }
            break
            
        case 3:
            blinkResult = 4
            //self.updateProofIndex(index: self.actualStateIndex)
            break
            
        default:break
        }
        
        
        var response = Selfie.BlinkDetector.Response()
        response.blinkResult = blinkResult
        response.glassesTimeStamps = glassesTimeStamps
        
        return response
    }
    
    
    func processBufferToPhoto(sampleBuffer: CMSampleBuffer?, ciContext : CIContext)-> Selfie.Photo.Response{
        var response = Selfie.Photo.Response(success: false, imgPhoto: nil, timeToTakeSelfie: 0.5)
        
        if let _ = sampleBuffer{
            let imageBuffer = CMSampleBufferGetImageBuffer(sampleBuffer!)
            let ciImage = CIImage(cvImageBuffer: imageBuffer!)
            let processImage = ciContext.createCGImage(ciImage, from: ciImage.extent)
            let uiimg = UIImage(cgImage: processImage!)
            let laplace = OpenCVManager.checkLaplaceValue(uiimg)
            if laplace > 120 {
                response.success = true
                response.imgPhoto = uiimg
                if !Constants.isProofLifeSelfie{
                    response.timeToTakeSelfie  = Double(Constants.timeToTakeSelfie)
                }
                
            }
        }
        
        return response
    }
    
    
    
}

// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertFromAVCaptureSessionPreset(_ input: AVCaptureSession.Preset) -> String {
	return input.rawValue
}

// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertFromAVMediaType(_ input: AVMediaType) -> String {
	return input.rawValue
}
